/* Grafick knihovna pro videoreim 0x13, 320x200x256
 * --------------------------------------------------
 * Copyright (c) 1999 Martin Hinner, <mhi@penguin.cz>
 */

/***********************************
 * Funkce: putpix
 *
 * Popis:  Nakresl na obrazovku bod na souadnice x,y o barv color.
 *         Souadnice jsou v rozmez [0,0]..[319,199] a barva je
 *         0..255. Pi kreslen se pouije aktuln paleta, viz funkce
 *         setpal.
 ****************************************************************************/
void putpix(int x,int y,int color)
{
 unsigned char far *vmem = (unsigned char far *)0xA0000000L;

 if (x>0 && x<320 && y>0 && y<200)
   vmem[x + 320*y] = color;
}

/***********************************
 * Funkce: initg
 *
 * Popis:  Tato funkce inicializuje grafick reim 320x200x256 pomoc
 *         slueb VGA-BIOSu.
 ****************************************************************************/
void initg(void)
{
 asm{ mov ax,0x13
   int 0x10
   }
}

/***********************************
 * Funkce: doneg
 *
 * Popis:  Ukon grafick reim a vrt se do textovho reimu.
 ****************************************************************************/
void doneg(void)
{
 asm{ mov ax,0x3
   int 0x10
   }
}

/***********************************
 * Funkce: setpal
 *
 * Popis:  Tato funkce nastav RGB sloky zadan barvy s indexem n. N me
 *         nabvat hodnot 0..255, tedy poet barev. Jednotliv sloky nabvaj
 *         hodnot 0..63.
 ****************************************************************************/
void setpal(int n,int r,int g,int b)
{
 outp(0x3c8,n);
 outp(0x3c9,r);
 outp(0x3c9,g);
 outp(0x3c9,b);
}
